#include "AudioHelper.h"

AudioHelper::AudioHelper() : sounds(0) {
}

AudioHelper::~AudioHelper() {
    if (sounds != 0) deleteSounds();
}

string AudioHelper::getMusicName(int id) {
    switch (id) {
        case 0 : return "D:\\data\\musics\\Titre.it";
        case 1 : return "D:\\data\\musics\\Fee.it";
        case 2 : return "D:\\data\\musics\\Mort.it";
        case 3 : return "D:\\data\\musics\\Plage.it";
        case 4 : return "D:\\data\\musics\\Jungle.it";
        case 5 : return "D:\\data\\musics\\Coquillages.it";
        case 6 : return "D:\\data\\musics\\Opening.it";
        case 7 : return "D:\\data\\musics\\Lac.it";
        case 8 : return "D:\\data\\musics\\Plaine.it";
        case 9 : return "D:\\data\\musics\\Falaises.it";
        case 10 : return "D:\\data\\musics\\Gemmes.it";
        case 11 : return "D:\\data\\musics\\Marais.it";
        case 12 : return "D:\\data\\musics\\Fontaine.it";
        case 13 : return "D:\\data\\musics\\Canyon.it";
        case 14 : return "D:\\data\\musics\\Desert.it";
        case 15 : return "D:\\data\\musics\\VillageO.it";
        case 16 : return "D:\\data\\musics\\Cimetiere.it";
        case 17 : return "D:\\data\\musics\\Mont.it";
        case 18 : return "D:\\data\\musics\\Cave.it";
        case 19 : return "D:\\data\\musics\\Boss.it";
        case 20 : return "D:\\data\\musics\\Epee.it";
        case 21 : return "D:\\data\\musics\\Magasin.it";
        case 22 : return "D:\\data\\musics\\Jeu.it";
        case 23 : return "D:\\data\\musics\\Maison.it";
        case 24 : return "D:\\data\\musics\\Maire.it";
        case 25 : return "D:\\data\\musics\\Bar.it";
        case 26 : return "D:\\data\\musics\\Colisee.it";
        case 27 : return "D:\\data\\musics\\Sorciere.it";
        case 28 : return "D:\\data\\musics\\DJungle.it";
        case 29 : return "D:\\data\\musics\\DTerre.it";
        case 30 : return "D:\\data\\musics\\DPyramide.it";
        case 31 : return "D:\\data\\musics\\DEau.it";
        case 32 : return "D:\\data\\musics\\DFeu.it";
        case 33 : return "D:\\data\\musics\\DOmbre.it";
        case 34 : return "D:\\data\\musics\\DGlace.it";
        case 35 : return "D:\\data\\musics\\DSecret.it";
        case 36 : return "D:\\data\\musics\\DFinal.it";
        case 37 : return "D:\\data\\musics\\DFinal2.it";
        case 38 : return "D:\\data\\musics\\BossF.it";
        case 39 : return "D:\\data\\musics\\End.it";
        default : return "";
    }
}

WSound* AudioHelper::getSound(int id) {
    return sounds[id];
}

void AudioHelper::loadSounds() {
    sounds = new WSound*[TS_NB_MAX];
    sounds[TS_MENU1] = new WSound("D:\\data\\sounds\\menu\\menu1.wav");
    sounds[TS_MENU2] = new WSound("D:\\data\\sounds\\menu\\menu2.wav");
    sounds[TS_MENU3] = new WSound("D:\\data\\sounds\\menu\\menu3.wav");

    sounds[TS_STEP_GRASS1] = new WSound("D:\\data\\sounds\\steps\\Steps_Grass1.wav");
    sounds[TS_STEP_GRASS2] = new WSound("D:\\data\\sounds\\steps\\Steps_Grass2.wav");
    sounds[TS_STEP_DIRT1] = new WSound("D:\\data\\sounds\\steps\\Steps_Dirt1.wav");
    sounds[TS_STEP_DIRT2] = new WSound("D:\\data\\sounds\\steps\\Steps_Dirt2.wav");
    sounds[TS_STEP_TALLGRASS1] = new WSound("D:\\data\\sounds\\steps\\Steps_TallGrass1.wav");
    sounds[TS_STEP_TALLGRASS2] = new WSound("D:\\data\\sounds\\steps\\Steps_TallGrass2.wav");
    sounds[TS_STEP_ICE1] = new WSound("D:\\data\\sounds\\steps\\Steps_Ice1.wav");
    sounds[TS_STEP_ICE2] = new WSound("D:\\data\\sounds\\steps\\Steps_Ice2.wav");
    sounds[TS_STEP_WATER1] = new WSound("D:\\data\\sounds\\steps\\Steps_Water1.wav");
    sounds[TS_STEP_WATER2] = new WSound("D:\\data\\sounds\\steps\\Steps_Water2.wav");
    sounds[TS_STEP_SAND1] = new WSound("D:\\data\\sounds\\steps\\Steps_Sand1.wav");
    sounds[TS_STEP_SAND2] = new WSound("D:\\data\\sounds\\steps\\Steps_Sand2.wav");
    sounds[TS_STEP_STONE1] = new WSound("D:\\data\\sounds\\steps\\Steps_Stone1.wav");
    sounds[TS_STEP_STONE2] = new WSound("D:\\data\\sounds\\steps\\Steps_Stone2.wav");
    sounds[TS_STEP_WOOD1] = new WSound("D:\\data\\sounds\\steps\\Steps_Wood1.wav");
    sounds[TS_STEP_WOOD2] = new WSound("D:\\data\\sounds\\steps\\Steps_Wood2.wav");
    sounds[TS_STEP_CARPET1] = new WSound("D:\\data\\sounds\\steps\\Steps_Carpet1.wav");
    sounds[TS_STEP_CARPET2] = new WSound("D:\\data\\sounds\\steps\\Steps_Carpet2.wav");


    sounds[TS_JUMP] = new WSound("D:\\data\\sounds\\link\\jump.wav");
    sounds[TS_NAGE] = new WSound("D:\\data\\sounds\\link\\nage.wav");
    sounds[TS_ATTACK1] = new WSound("D:\\data\\sounds\\link\\attack1.wav");
    sounds[TS_ATTACK2] = new WSound("D:\\data\\sounds\\link\\attack2.wav");
    sounds[TS_ATTACK3] = new WSound("D:\\data\\sounds\\link\\attack3.wav");
    sounds[TS_ATTACK4] = new WSound("D:\\data\\sounds\\link\\attack4.wav");
    sounds[TS_HURT] = new WSound("D:\\data\\sounds\\link\\hurt.wav");
    sounds[TS_DANGER] = new WSound("D:\\data\\sounds\\link\\danger.wav");
    sounds[TS_HEART] = new WSound("D:\\data\\sounds\\link\\heart.wav");
    sounds[TS_RUPEE] = new WSound("D:\\data\\sounds\\link\\rupee.wav");
    sounds[TS_SPIN] = new WSound("D:\\data\\sounds\\link\\spin.wav");
    sounds[TS_ITEM] = new WSound("D:\\data\\sounds\\link\\item.wav");
    sounds[TS_FALL] = new WSound("D:\\data\\sounds\\link\\fall.wav");
    sounds[TS_MAGICCHARGE] = new WSound("D:\\data\\sounds\\link\\charge.wav");
    sounds[TS_HAPPY] = new WSound("D:\\data\\sounds\\link\\happy.wav");
    sounds[TS_SHOOT] = new WSound("D:\\data\\sounds\\link\\shoot.wav");
    sounds[TS_THROW] = new WSound("D:\\data\\sounds\\link\\lance.wav");
    sounds[TS_PORTE] = new WSound("D:\\data\\sounds\\link\\porte.wav");
    sounds[TS_GRAPPIN] = new WSound("D:\\data\\sounds\\link\\hookshot.wav");
    sounds[TS_MAGIC] = new WSound("D:\\data\\sounds\\link\\magic.wav");
    sounds[TS_MARTEAU] = new WSound("D:\\data\\sounds\\link\\hammer.wav");
    sounds[TS_PLOT] = new WSound("D:\\data\\sounds\\link\\plot.wav");
    sounds[TS_CAPE_ON] = new WSound("D:\\data\\sounds\\link\\capeon.wav");
    sounds[TS_CAPE_OFF] = new WSound("D:\\data\\sounds\\link\\capeoff.wav");
    sounds[TS_CANE] = new WSound("D:\\data\\sounds\\link\\cane.wav");
    sounds[TS_BYRNA] = new WSound("D:\\data\\sounds\\link\\byrna.wav");
    sounds[TS_SHOCK] = new WSound("D:\\data\\sounds\\link\\shock.wav");
    sounds[TS_BOOMERANG] = new WSound("D:\\data\\sounds\\link\\boomerang.wav");
    sounds[TS_BAGUETTE_FEU] = new WSound("D:\\data\\sounds\\link\\baguetteFeu.wav");
    sounds[TS_BAGUETTE_GLACE] = new WSound("D:\\data\\sounds\\link\\baguetteGlace.wav");


    sounds[TS_NAVY_HEY] = new WSound("D:\\data\\sounds\\link\\hey.wav");
    sounds[TS_NAVY_LISTEN] = new WSound("D:\\data\\sounds\\link\\listen.wav");
    sounds[TS_NAVY_HELLO] = new WSound("D:\\data\\sounds\\link\\hello.wav");
    sounds[TS_NAVY_LOOK] = new WSound("D:\\data\\sounds\\link\\look.wav");

    sounds[TS_SONG_1] = new WSound("D:\\data\\sounds\\ocarina\\zelda.wav");
    sounds[TS_SONG_2] = new WSound("D:\\data\\sounds\\ocarina\\envol.wav");
    sounds[TS_SONG_3] = new WSound("D:\\data\\sounds\\ocarina\\vide.wav");

    sounds[TS_SWORD] = new WSound("D:\\data\\sounds\\items\\sword.wav");
    sounds[TS_SWORDCHARGING] = new WSound("D:\\data\\sounds\\items\\SwordCharging.wav");

    sounds[TS_HITENNEMY] = new WSound("D:\\data\\sounds\\others\\hitenemy.wav");
    sounds[TS_KILLENNEMY] = new WSound("D:\\data\\sounds\\others\\killenemy.wav");
    sounds[TS_PLOUF] = new WSound("D:\\data\\sounds\\others\\plouf.wav");
    sounds[TS_SOL] = new WSound("D:\\data\\sounds\\others\\stamp.wav");
    sounds[TS_BOOM] = new WSound("D:\\data\\sounds\\others\\bomb.wav");
    sounds[TS_TOMBE] = new WSound("D:\\data\\sounds\\others\\tombe.wav");
    sounds[TS_BURN] = new WSound("D:\\data\\sounds\\others\\burn.wav");
    sounds[TS_BUISSON] = new WSound("D:\\data\\sounds\\others\\buisson.wav");
    sounds[TS_DOOR] = new WSound("D:\\data\\sounds\\others\\door.wav");
    sounds[TS_SURPRISE] = new WSound("D:\\data\\sounds\\others\\surprise.wav");
    sounds[TS_ERROR] = new WSound("D:\\data\\sounds\\others\\error.wav");
    sounds[TS_ESCALIERS_DOWN] = new WSound("D:\\data\\sounds\\others\\descend.wav");
    sounds[TS_ESCALIERS_UP] = new WSound("D:\\data\\sounds\\others\\monte.wav");
    sounds[TS_TELEPORT] = new WSound("D:\\data\\sounds\\others\\timewarp.wav");

    sounds[TS_PUSH] = new WSound("D:\\data\\sounds\\objects\\push.wav");
    sounds[TS_BREAK] = new WSound("D:\\data\\sounds\\objects\\casse.wav");
    sounds[TS_COFFRE] = new WSound("D:\\data\\sounds\\objects\\coffre.wav");
    sounds[TS_POULE] = new WSound("D:\\data\\sounds\\objects\\poule.wav");
    sounds[TS_PICS] = new WSound("D:\\data\\sounds\\objects\\pics.wav");

    sounds[TS_TEXT] = new WSound("D:\\data\\sounds\\texts\\text.wav");
    sounds[TS_TEXTNEXT] = new WSound("D:\\data\\sounds\\texts\\textnext.wav");
    sounds[TS_TEXTEND] = new WSound("D:\\data\\sounds\\texts\\textend.wav");


}

void AudioHelper::deleteSounds() {
    if (sounds != 0) {
        for (int i = 0; i < TS_NB_MAX; i++) {
            delete sounds[i];
        }
        delete[] sounds;
    }
}

int AudioHelper::getNbSounds() {
    return TS_NB_MAX;
}
