/*

    Zelda Navi's Quest

    Copyright (C) 2013-2014  Vincent Jouillat

    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/

#ifndef __WINDOWMANAGER_H__
#define __WINDOWMANAGER_H__

#include <xtl.h>
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_rotozoom.h>
#include "../../xbox/xboxJoy.h"
#include "../../xbox/xresizer.h"
#include "../common/Common.h"
#include "Event.h"

#include "../resources/WImage.h"

class WindowManager {
    public :
        static WindowManager* getInstance();
        int createWindow(string title, string icon);
        bool isOpened();
        Event* getEvent();
        void close();
        void display();

        void draw(WImage* image, int srcX, int srcY, int srcW, int srcH, int dstX, int dstY, int alpha = 255);
        void draw(SDL_Surface* object);

        void exit();

        SDL_Surface* window;
        SDL_Surface* windowTmp;

    private :
        WindowManager();
        ~WindowManager();
        static WindowManager instance;

        bool isFullScreen;
        string name;
        Event* event;

        Uint32 lastAnimTime;
        bool open;

		int XBUTTON, XPAD, XJOY, XAXIS, YAXIS, LXAXIS, LYAXIS, oldLYAXIS, oldLAXIS;
};

#endif  // WindowManager.h
